﻿#ProgName = "DFU_Prog 1.0"       ; Имя и версия программы.

XIncludeFile "Form.pbf"
XIncludeFile "DFU.pbi"
UseModule DFU


#SettingFile = "DFU_Setting.ini" ; Файл настроек
#PathHistory_Count = 30          ; Количество запоминаемых путей к файлам.

Enumeration
  #BootType_Flash  ; Прошивка памяти программ.
  #BootType_EEPROM ; Прошивка памяти данных.
  #BootType_RunApp ; Запуск программы.
EndEnumeration

Enumeration
  #FileProg
EndEnumeration

Structure ArrA
  a.a[0]
EndStructure


EnableExplicit

Define Event, Gadget, File.s

Macro Message(Text)
  MessageRequester(#ProgName, Text)
EndMacro

Procedure.s ChipTypeToName(ChipType.b)
  Protected Res.s
  
  Select ChipType
    ; ATmega.
    Case #DFU_ChipType_USB82   : Res = "AT90USB82"
    Case #DFU_ChipType_USB162  : Res = "AT90USB162"
    Case #DFU_ChipType_USB646  : Res = "AT90USB646"
    Case #DFU_ChipType_USB647  : Res = "AT90USB647"
    Case #DFU_ChipType_USB1286 : Res = "AT90USB1286"
    Case #DFU_ChipType_USB1287 : Res = "AT90USB1287"
    Case #DFU_ChipType_16U4    : Res = "ATmega16U4"
    Case #DFU_ChipType_32U4    : Res = "ATmega32U4"
    Case  #DFU_ChipType_16U4   : Res = "ATmega16U4"
    Case  #DFU_ChipType_32U4   : Res = "ATmega32U4"
    Case  #DFU_ChipType_32U6   : Res = "ATmega32U6"
    Case  #DFU_ChipType_16U2   : Res = "ATmega16U2"
    Case  #DFU_ChipType_32U2   : Res = "ATmega32U2"
    ; ATxmega
    Case  #DFU_ChipType_XMEGA64C3   : Res = "ATxmega64C3"
    Case  #DFU_ChipType_XMEGA128C3  : Res = "ATxmega128C3"
    Case  #DFU_ChipType_XMEGA16C4   : Res = "ATxmega16C4"
    Case  #DFU_ChipType_XMEGA32C4   : Res = "ATxmega32C4"
    Case  #DFU_ChipType_XMEGA256C3  : Res = "ATxmega256C3"
    Case  #DFU_ChipType_XMEGA384C3  : Res = "ATxmega384C3"
    Case  #DFU_ChipType_XMEGA64A4U  : Res = "ATxmega64A4U"
    Case  #DFU_ChipType_XMEGA128A4U : Res = "ATxmega128A4U"
    Case  #DFU_ChipType_XMEGA64B3   : Res = "ATxmegaA64B3"
    Case  #DFU_ChipType_XMEGA128B3  : Res = "ATxmega128B3"
    Case  #DFU_ChipType_XMEGA64B1   : Res = "ATxmega64B1"
    Case  #DFU_ChipType_XMEGA256A3BU: Res = "ATxmega256A3BU"
    Case  #DFU_ChipType_XMEGA16A4U  : Res = "ATxmega16A4U"
    Case  #DFU_ChipType_XMEGA32A4U  : Res = "ATxmega32A4U"
    Case  #DFU_ChipType_XMEGA64A3U  : Res = "ATxmega64A3U"
    Case  #DFU_ChipType_XMEGA128A3U : Res = "ATxmega128A3U"
    Case  #DFU_ChipType_XMEGA192A3U : Res = "ATxmega192A3U"
    Case  #DFU_ChipType_XMEGA64A1U  : Res = "ATxmega64A1U"
    Case  #DFU_ChipType_XMEGA128B1  : Res = "ATxmega128B1"
    Case  #DFU_ChipType_XMEGA256A3U : Res = "ATxmega256A3U"
    Case  #DFU_ChipType_XMEGA128A1U : Res = "ATxmega128A1U"
    ; AT32
    Case  #DFU_ChipType_AT32UCL3_L4 : Res = "AT32UCL3 / L4"
    Case  #DFU_ChipType_AT32UC3D    : Res = "AT32UC3D"
    Case  #DFU_ChipType_AT32UC3C    : Res = "AT32UC3C"
    Case  #DFU_ChipType_AT32UC3A    : Res = "AT32UC3A"
    Case  #DFU_ChipType_AT32UC3A3   : Res = "AT32UC3A3"
    Case  #DFU_ChipType_AT32AP7200  : Res = "AT32AP7200"
    Case  #DFU_ChipType_AT32UC3B    : Res = "AT32UC3B"
    Default : Res = "????"
  EndSelect
  
  ProcedureReturn Res
EndProcedure

Procedure.s ErrToText(ErrCode.l)
  Protected Str.s=""
  
  Select ErrCode
    Case #DFU_Err_OK
      ;Str = "Ошибок нет."
    Case #DFU_Err_NoInit
      Str = "Библиотека не инициализирована."
    Case #DFU_Err_ChipBad
      Str = "Неподдерживаемый тип микроконтроллра."
    Case #DFU_Err_Internal
      Str = "Внутреняя ошибка программы."
    Case #DFU_Err_NotChip
      Str = "Не найден выбранный микроконтроллер."
    Case #DFU_Err_OpenDev
      Str = "Ошибка установки связи с USB устройством (загрузчиком)."
    Case #DFU_Err_ConfigDev
      Str = "Ошибка конфигурации или интерфейса USB."
    Case #DFU_Err_DevNotRespond
      Str = "Загрузчик не ответил на запрос."
    Case #DFU_Err_BadParam
      Str = "Некорректный параметр функции."
    Case #DFU_Err_TimeOut
      Str = "Выход по таймауту."
    Case #DFU_Err_DownFunct
      Str = "Ошибка при отправке данных загрузчику."
    Case #DFU_Err_UpFunct
      Str = "Ошибка при получении данных от загрузчика."
    Case #DFU_Err_IncorrectFile
      Str = "Некорректный файл."
    Case #DFU_Err_OpenFile
      Str = "Не удалось открыть файл."
    Case #DFU_Err_IncorrectData
      Str = "Несовпадение данных, например при проверке записанной прошивки в МК."
    Case #DFU_Err_StatusParam
      Str = "Ошибка функции статуса."
    Case #DFU_Err_ProtectMem
      Str = "Память защищена."
  EndSelect
  
  ProcedureReturn Str
EndProcedure

Procedure LoadPref(File.s) ; Чтение настроек программы.
  Protected Open, i, x, s.s
  
  Open = OpenPreferences(File)
  
  SetGadgetState(#Combo_Chip, ReadPreferenceLong("ChipSel", 0))
  SetGadgetState(#Checkbox_Test, Bool(ReadPreferenceLong("Verification", 1)))
  
  PreferenceGroup("PathHistory") ; История выбранных прошивок.
  x = ReadPreferenceLong("Count", 0)
  If x>0
    
    If x>#PathHistory_Count
      x=#PathHistory_Count
    EndIf
    
    For i=1 To x
      s = ReadPreferenceString("Path_"+i, "")
      If s<>""
        AddGadgetItem(#Combo_Path, -1, s)
      EndIf
    Next i
    
    SetGadgetState(#Combo_Path, 0)
    
  EndIf
  
  If Open
    ClosePreferences()
  EndIf
EndProcedure

Procedure SavePref(File.s) ; Запись настроек программы.
  Protected i, x, s.s
  
  If CreatePreferences(File)
    
    WritePreferenceLong("ChipSel", GetGadgetState(#Combo_Chip))
    WritePreferenceLong("Verification", GetGadgetState(#Checkbox_Test))
    
    PreferenceGroup("PathHistory") ; История выбранных прошивок.
    x = CountGadgetItems(#Combo_Path)
    WritePreferenceLong("Count", x)
    
    x-1
    
    For i=0 To x
      s = GetGadgetItemText(#Combo_Path, i)
      If s<>""
        WritePreferenceString("Path_"+Str(i+1), s)
      EndIf
    Next
    
    ClosePreferences()
  EndIf
EndProcedure

Procedure Init()
  Protected i
  
  SetCurrentDirectory(GetPathPart(ProgramFilename()))
  
  AddGadgetItem(#Combo_Chip, -1, "Auto")
  For i=#DFU_ChipType_Auto+1 To #DFU_ChipType_Max-1
    AddGadgetItem(#Combo_Chip, -1, ChipTypeToName(i))
  Next i
  
  LoadPref(#SettingFile)
  
  
EndProcedure

Procedure ProgressProg(Pos)
  SetGadgetState(#ProgressBar_Prog, Pos)
EndProcedure

Procedure ShowText_Scroll(Gadget, Text.s)
  AddGadgetItem(Gadget, -1, Text)
  ;SetGadgetState(Gadget, CountGadgetItems(Gadget)-1)
  Repeat : Until WindowEvent() = 0
EndProcedure

Macro ShowErr(Text="")
  ShowText_Scroll(#ListView_Log, Text+"ОШИБКА - "+ErrToText(DFU_GetLastErr()))
EndMacro

Procedure ReadFileInMem(File.s, *Size.Long)
  Protected *Mem = 0, SizeFile.q
  
  If File<>"" And *Size
    If ReadFile(#FileProg, File)
      SizeFile = Lof(#FileProg)
      If SizeFile>0 And SizeFile<10000000
        *Mem = AllocateMemory(SizeFile)
        If *Mem
          If ReadData(#FileProg, *Mem, SizeFile) = SizeFile
            *Size\l = SizeFile
          Else
            FreeMemory(*Mem)
            *Mem=0
          EndIf
        EndIf
      EndIf
      CloseFile(#FileProg)
    EndIf
  EndIf
  
  ProcedureReturn *Mem
EndProcedure

Procedure AddFileInComboBox(File.s)
  Protected i, x
  
  x=CountGadgetItems(#Combo_Path)-1
  
  For i=0 To x
    If File = GetGadgetItemText(#Combo_Path, i)
      RemoveGadgetItem(#Combo_Path, i)
      i-1
      x-1
    EndIf
  Next i
  
  AddGadgetItem(#Combo_Path, 0, File)
  SetGadgetState(#Combo_Path, 0)
  
EndProcedure

; Процедура "общения" с загрузчиком микроконтроллера.
Procedure BootIO(Type.a,        ; Тип операции. См. константы #BootType_xxxx.
                 Check.a=#False, ; Проверка правильности записи данных.
                 File.s="")      ; Путь к файлу.
  Protected hDev.i, SizeL.l
  Protected Info.DFU_ChipParam
  Protected *WriteBuff.ArrA=0, *ReadBuff.ArrA=0
  Protected MemType, MType.s, x
  
  ClearGadgetItems(#ListView_Log)
  SetGadgetState(#ProgressBar_Prog, 0)
  
  If (Type = #BootType_Flash Or Type = #BootType_EEPROM) And
     (File="" Or FileSize(File)<=0)
    Message("Файл не выбран!")
    ProcedureReturn
  EndIf
  
  hDev = DFU_DevOpen(GetGadgetState(#Combo_Chip))
  If hDev
    DFU_SetProgressCB(hDev, @ProgressProg())
    
    AddGadgetItem(#ListView_Log, -1, "Связь с загрузчиком установлена")
    
    Repeat : Until WindowEvent() = 0
    
    If DFU_ChipInfo(hDev, @Info)
      AddGadgetItem(#ListView_Log, -1, "")
      AddGadgetItem(#ListView_Log, -1, "Микроконтроллер - "+ChipTypeToName(Info\ChipType))
      AddGadgetItem(#ListView_Log, -1, "Версия загрузчика - 1."+RSet(Str(Info\BootVersion), 2, "0"))
      AddGadgetItem(#ListView_Log, -1, "Boot ID - "+RSet(Hex(Info\bootID1, #PB_Ascii), 2, "0")+
                                       " "+RSet(Hex(Info\bootID2, #PB_Ascii), 2, "0"))
      AddGadgetItem(#ListView_Log, -1, "Сигнатура - "+RSet(Hex(Info\Manufacturer, #PB_Ascii), 2, "0")+
                                       " "+RSet(Hex(Info\Family, #PB_Ascii), 2, "0")+
                                       " "+RSet(Hex(Info\ProductName, #PB_Ascii), 2, "0")+
                                       " "+RSet(Hex(Info\Revision, #PB_Ascii), 2, "0"))
      AddGadgetItem(#ListView_Log, -1, "")
    EndIf
    
    Repeat : Until WindowEvent() = 0
    
    If Type = #BootType_Flash Or Type = #BootType_EEPROM
      
      AddFileInComboBox(File)
    
      If Type = #BootType_Flash
        MemType = #DFU_MemType_Flash
        MType="Flash"
      Else
        MemType = #DFU_MemType_EEPROM
        MType="EEPROM"
      EndIf
      
      SizeL = 0
      *WriteBuff = ReadFileInMem(File, @SizeL)
      
      If *WriteBuff<>0 And SizeL>0
        
        x = #True
        
        If Type = #BootType_Flash
          If DFU_EraseFlash(hDev)>=0
            ShowText_Scroll(#ListView_Log, "Память успешно очищена")
          Else
            ShowErr("Очистка памяти ")
            x = #False
          EndIf
        EndIf
        
        If x = #True
          ShowText_Scroll(#ListView_Log, "Начало прошивки "+MType)
          
          If DFU_WriteBuff(hDev, *WriteBuff, SizeL, MemType)
            ShowText_Scroll(#ListView_Log, "Прошивка успешно завершна")
            
            If Check
              ShowText_Scroll(#ListView_Log, "Начало проверки")
              *ReadBuff = AllocateMemory(SizeL)
              If *ReadBuff
                If DFU_ReadBuff(hDev, *ReadBuff, SizeL, MemType)
                  SizeL - 1
                  For x = 0  To SizeL
                    If *WriteBuff\a[x]<>*WriteBuff\a[x]
                      ShowText_Scroll(#ListView_Log, "Несовпадение данных по адресу "+
                                                     Hex(x, #PB_Long))
                      ShowText_Scroll(#ListView_Log, "В микроконтроллере "+
                                                     Hex(*ReadBuff\a[x], #PB_Ascii)+
                                                     "  в буфере "+Hex(*WriteBuff\a[x], #PB_Ascii))
                      Break
                    EndIf
                  Next x
                  
                  If x>SizeL
                    ShowText_Scroll(#ListView_Log, "Успешная проверка данных")
                  EndIf
                  
                Else
                  ShowErr()
                EndIf
              EndIf
            EndIf
            
          Else
            ShowErr()
          EndIf
          
        EndIf
        
      Else
        AddGadgetItem(#ListView_Log, -1, "Не удалось прочитать файл прошивки")
      EndIf
      
      If *ReadBuff
        FreeMemory(*ReadBuff)
        *ReadBuff = 0
      EndIf
      
      If *WriteBuff
        FreeMemory(*WriteBuff)
        *WriteBuff = 0
      EndIf
      
    ElseIf Type = #BootType_RunApp
      If DFU_StartApp(hDev)
        AddGadgetItem(#ListView_Log, -1, "Программа успешно запущена")
      Else
        ShowErr()
      EndIf
    EndIf
    
    DFU_DevClose(hDev)
  Else
    ShowErr()
  EndIf
  
EndProcedure


If DFU_Init()=0
  Message("Ошибка инициализации USB библиотеки"+
                              "Возможно не установлен драйвер")
  End
EndIf



OpenWinMain()
Init()

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  SetWindowTitle(#WinMain, GetWindowTitle(#WinMain)+"  x64")
CompilerEndIf



Repeat
  Event = WaitWindowEvent()
  
  If Event = #PB_Event_Gadget
    Select EventGadget()
      Case #Combo_Path
      Case #Button_Path
        File = GetGadgetText(#Combo_Path)
        If File And FileSize(File)<=0
          File=""
        EndIf
        File = OpenFileRequester("", File, "Прошивки|*.bin;*.epp|Все файлы|*.*", 0)
        If File
          SetGadgetText(#Combo_Path, File)
        EndIf
      Case #Button_Flash
        BootIO(#BootType_Flash, GetGadgetState(#Checkbox_Test), GetGadgetText(#Combo_Path))
      Case #Button_EEPROM
        BootIO(#BootType_EEPROM, GetGadgetState(#Checkbox_Test), GetGadgetText(#Combo_Path))
      Case #Button_RunAp
        BootIO(#BootType_RunApp)
    EndSelect
  EndIf
  
Until Event = #PB_Event_CloseWindow

SavePref(#SettingFile)
; IDE Options = PureBasic 6.00 LTS - C Backend (Linux - arm64)
; CursorPosition = 307
; FirstLine = 301
; Folding = ---
; EnableXP
; Executable = DFU_Prog_arm32
; SubSystem = qt
; CompileSourceDirectory
; EnableUnicode